Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2696)
@@ -4409,7 +5519,341 @@
                          READ ( 13 )  tmp_surf_v(3)%t
                       ENDIF
-                      CALL restore_surface_elements_usm_1d(                    &
+                      CALL surface_restore_elements(                           &
                                               t_surf_v_1(3)%t, tmp_surf_v(3)%t,&
-                                              surf_usm_v(3)%start_index )
+                                              surf_usm_v(3)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#endif
+                   CASE ( 't_surf_green_h' )
+#if defined( __nopointer )                   
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_green_h ) )                   &
+                            ALLOCATE( t_surf_green_h(1:surf_usm_h%ns) )
+                         READ ( 13 )  tmp_surf_green_h
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_green_h, tmp_surf_green_h, &
+                                              surf_usm_h%start_index,          & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#else                      
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_green_h_1 ) )                 &
+                            ALLOCATE( t_surf_green_h_1(1:surf_usm_h%ns) )
+                         READ ( 13 )  tmp_surf_green_h
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_green_h_1, tmp_surf_green_h, &
+                                              surf_usm_h%start_index,          & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#endif
+
+                   CASE ( 't_surf_green_v(0)' )
+#if defined( __nopointer )            
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_green_v(0)%t ) )              &
+                            ALLOCATE( t_surf_green_v(0)%t(1:surf_usm_v(0)%ns) )
+                         READ ( 13 )  tmp_surf_green_v(0)%t
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_green_v(0)%t, tmp_surf_green_v(0)%t,  &
+                                              surf_usm_v(0)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#else                      
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_green_v_1(0)%t ) )            &
+                            ALLOCATE( t_surf_green_v_1(0)%t(1:surf_usm_v(0)%ns) )
+                         READ ( 13 )  tmp_surf_green_v(0)%t
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_green_v_1(0)%t, tmp_surf_green_v(0)%t,&
+                                              surf_usm_v(0)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#endif
+                         
+                   CASE ( 't_surf_green_v(1)' )
+#if defined( __nopointer )        
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_green_v(1)%t ) )              &
+                            ALLOCATE( t_surf_green_v(1)%t(1:surf_usm_v(1)%ns) )
+                         READ ( 13 )  tmp_surf_green_v(1)%t
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_green_v(1)%t, tmp_surf_green_v(1)%t,  &
+                                              surf_usm_v(1)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )                 
+#else                      
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_green_v_1(1)%t ) )            &
+                            ALLOCATE( t_surf_green_v_1(1)%t(1:surf_usm_v(1)%ns) )
+                         READ ( 13 )  tmp_surf_green_v(1)%t
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_green_v_1(1)%t, tmp_surf_green_v(1)%t,&
+                                              surf_usm_v(1)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#endif
+
+                   CASE ( 't_surf_green_v(2)' )
+#if defined( __nopointer )          
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_green_v(2)%t ) )              &
+                            ALLOCATE( t_surf_green_v(2)%t(1:surf_usm_v(2)%ns) )
+                         READ ( 13 )  tmp_surf_green_v(2)%t
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_green_v(2)%t, tmp_surf_green_v(2)%t,  &
+                                              surf_usm_v(2)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#else                      
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_green_v_1(2)%t ) )            &
+                            ALLOCATE( t_surf_green_v_1(2)%t(1:surf_usm_v(2)%ns) )
+                         READ ( 13 )  tmp_surf_green_v(2)%t
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_green_v_1(2)%t, tmp_surf_green_v(2)%t,&
+                                              surf_usm_v(2)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#endif
+                         
+                   CASE ( 't_surf_green_v(3)' )
+#if defined( __nopointer )    
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_green_v(3)%t ) )              &
+                            ALLOCATE( t_surf_green_v(3)%t(1:surf_usm_v(3)%ns) )
+                         READ ( 13 )  tmp_surf_green_v(3)%t
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_green_v(3)%t, tmp_surf_green_v(3)%t,  &
+                                              surf_usm_v(3)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#else                      
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_green_v_1(3)%t ) )            &
+                            ALLOCATE( t_surf_green_v_1(3)%t(1:surf_usm_v(3)%ns) )
+                         READ ( 13 )  tmp_surf_green_v(3)%t
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_green_v_1(3)%t, tmp_surf_green_v(3)%t,&
+                                              surf_usm_v(3)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#endif
+                   CASE ( 't_surf_window_h' )
+#if defined( __nopointer )                   
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_window_h ) )                   &
+                            ALLOCATE( t_surf_window_h(1:surf_usm_h%ns) )
+                         READ ( 13 )  tmp_surf_window_h
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_window_h, tmp_surf_window_h,            &
+                                              surf_usm_h%start_index,          & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#else                      
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_window_h_1 ) )                 &
+                            ALLOCATE( t_surf_window_h_1(1:surf_usm_h%ns) )
+                         READ ( 13 )  tmp_surf_window_h
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_window_h_1, tmp_surf_window_h,          &
+                                              surf_usm_h%start_index,          & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#endif
+
+                   CASE ( 't_surf_window_v(0)' )
+#if defined( __nopointer )            
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_window_v(0)%t ) )              &
+                            ALLOCATE( t_surf_window_v(0)%t(1:surf_usm_v(0)%ns) )
+                         READ ( 13 )  tmp_surf_window_v(0)%t
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_window_v(0)%t, tmp_surf_window_v(0)%t,  &
+                                              surf_usm_v(0)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#else                      
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_window_v_1(0)%t ) )            &
+                            ALLOCATE( t_surf_window_v_1(0)%t(1:surf_usm_v(0)%ns) )
+                         READ ( 13 )  tmp_surf_window_v(0)%t
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_window_v_1(0)%t, tmp_surf_window_v(0)%t,&
+                                              surf_usm_v(0)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#endif
+                         
+                   CASE ( 't_surf_window_v(1)' )
+#if defined( __nopointer )        
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_window_v(1)%t ) )              &
+                            ALLOCATE( t_surf_window_v(1)%t(1:surf_usm_v(1)%ns) )
+                         READ ( 13 )  tmp_surf_window_v(1)%t
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_window_v(1)%t, tmp_surf_window_v(1)%t,  &
+                                              surf_usm_v(1)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )                 
+#else                      
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_window_v_1(1)%t ) )            &
+                            ALLOCATE( t_surf_window_v_1(1)%t(1:surf_usm_v(1)%ns) )
+                         READ ( 13 )  tmp_surf_window_v(1)%t
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_window_v_1(1)%t, tmp_surf_window_v(1)%t,&
+                                              surf_usm_v(1)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#endif
+
+                   CASE ( 't_surf_window_v(2)' )
+#if defined( __nopointer )          
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_window_v(2)%t ) )              &
+                            ALLOCATE( t_surf_window_v(2)%t(1:surf_usm_v(2)%ns) )
+                         READ ( 13 )  tmp_surf_window_v(2)%t
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_window_v(2)%t, tmp_surf_window_v(2)%t,  &
+                                              surf_usm_v(2)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#else                      
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_window_v_1(2)%t ) )            &
+                            ALLOCATE( t_surf_window_v_1(2)%t(1:surf_usm_v(2)%ns) )
+                         READ ( 13 )  tmp_surf_window_v(2)%t
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_window_v_1(2)%t, tmp_surf_window_v(2)%t,&
+                                              surf_usm_v(2)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#endif
+                         
+                   CASE ( 't_surf_window_v(3)' )
+#if defined( __nopointer )    
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_window_v(3)%t ) )              &
+                            ALLOCATE( t_surf_window_v(3)%t(1:surf_usm_v(3)%ns) )
+                         READ ( 13 )  tmp_surf_window_v(3)%t
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_window_v(3)%t, tmp_surf_window_v(3)%t,  &
+                                              surf_usm_v(3)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+#else                      
+                      IF ( kk == 1 )  THEN
+                         IF ( .NOT.  ALLOCATED( t_surf_window_v_1(3)%t ) )            &
+                            ALLOCATE( t_surf_window_v_1(3)%t(1:surf_usm_v(3)%ns) )
+                         READ ( 13 )  tmp_surf_window_v(3)%t
+                      ENDIF
+                      CALL surface_restore_elements(                           &
+                                              t_surf_window_v_1(3)%t, tmp_surf_window_v(3)%t,&
+                                              surf_usm_v(3)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
 #endif
                    CASE ( 't_wall_h' )
@@ -4420,7 +5864,13 @@
                          READ ( 13 )  tmp_wall_h
                       ENDIF
-                      CALL restore_surface_elements_usm_2d(                    &
+                      CALL surface_restore_elements(                           &
                                               t_wall_h, tmp_wall_h,            &
-                                              surf_usm_h%start_index )
+                                              surf_usm_h%start_index,          & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
 #else
                       IF ( kk == 1 )  THEN
@@ -4429,7 +5879,13 @@
                          READ ( 13 )  tmp_wall_h
                       ENDIF
-                      CALL restore_surface_elements_usm_2d(                    &
+                      CALL surface_restore_elements(                           &
                                               t_wall_h_1, tmp_wall_h,          &
-                                              surf_usm_h%start_index )
+                                              surf_usm_h%start_index,          & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
 #endif
                    CASE ( 't_wall_v(0)' )
@@ -4440,7 +5896,13 @@
                          READ ( 13 )  tmp_wall_v(0)%t
                       ENDIF
-                      CALL restore_surface_elements_usm_2d(                    &
+                      CALL surface_restore_elements(                           &
                                               t_wall_v(0)%t, tmp_wall_v(0)%t,  &
-                                              surf_usm_v(0)%start_index )
+                                              surf_usm_v(0)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
 #else
                       IF ( kk == 1 )  THEN
@@ -4449,7 +5911,13 @@
                          READ ( 13 )  tmp_wall_v(0)%t
                       ENDIF
-                      CALL restore_surface_elements_usm_2d(                    &
+                      CALL surface_restore_elements(                           &
                                               t_wall_v_1(0)%t, tmp_wall_v(0)%t,&
-                                              surf_usm_v(0)%start_index )
+                                              surf_usm_v(0)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
 #endif
                    CASE ( 't_wall_v(1)' )
@@ -4460,7 +5928,12 @@
                          READ ( 13 )  tmp_wall_v(1)%t
                       ENDIF
-                      CALL restore_surface_elements_usm_2d(                    &
+                      CALL surface_restore_elements(                           &
                                               t_wall_v(1)%t, tmp_wall_v(1)%t,  &
-                                              surf_usm_v(1)%start_index )
+                                              surf_usm_v(1)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file ,              &
+                                              nxlc, nysc,           ,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
 #else
                       IF ( kk == 1 )  THEN
@@ -4469,7 +5942,13 @@
                          READ ( 13 )  tmp_wall_v(1)%t
                       ENDIF
-                      CALL restore_surface_elements_usm_2d(                    &
+                      CALL surface_restore_elements(                           &
                                               t_wall_v_1(1)%t, tmp_wall_v(1)%t,&
-                                              surf_usm_v(1)%start_index )
+                                              surf_usm_v(1)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
 #endif
                    CASE ( 't_wall_v(2)' )
@@ -4480,7 +5959,13 @@
                          READ ( 13 )  tmp_wall_v(2)%t
                       ENDIF
-                      CALL restore_surface_elements_usm_2d(                    &
+                      CALL surface_restore_elements(                           &
                                               t_wall_v(2)%t, tmp_wall_v(2)%t,  &
-                                              surf_usm_v(2)%start_index )
+                                              surf_usm_v(2)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
 #else
                       IF ( kk == 1 )  THEN
@@ -4489,7 +5974,13 @@
                          READ ( 13 )  tmp_wall_v(2)%t
                       ENDIF
-                      CALL restore_surface_elements_usm_2d(                    &
+                      CALL surface_restore_elements(                           &
                                               t_wall_v_1(2)%t, tmp_wall_v(2)%t,&
-                                              surf_usm_v(2)%start_index )
+                                              surf_usm_v(2)%start_index,       & 
+                                              start_index_on_file,             &
+                                              end_index_on_file ,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
 #endif
                    CASE ( 't_wall_v(3)' )
